commit 068fce9743ec9f3181c189cb8d03a982ca30eb7e
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Mon Jan 16 21:30:56 2023 +0100

    Fortran: fix ICE in get_expr_storage_size [PR108421]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/108421
            * interface.c (get_expr_storage_size): Check that we actually have
            an integer value before trying to extract it with mpz_get_si.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/108421
            * gfortran.dg/pr108421.f90: New test.
    
    (cherry picked from commit a75760374ee54768e5fd6a27080698bfbbd041ab)

diff --git a/gcc/fortran/interface.c b/gcc/fortran/interface.c
index 19ba7fd65dc..3fff18bd226 100644
--- a/gcc/fortran/interface.c
+++ b/gcc/fortran/interface.c
@@ -2810,7 +2810,8 @@ get_expr_storage_size (gfc_expr *e)
   if (e->ts.type == BT_CHARACTER)
     {
       if (e->ts.u.cl && e->ts.u.cl->length
-          && e->ts.u.cl->length->expr_type == EXPR_CONSTANT)
+	  && e->ts.u.cl->length->expr_type == EXPR_CONSTANT
+	  && e->ts.u.cl->length->ts.type == BT_INTEGER)
 	strlen = mpz_get_si (e->ts.u.cl->length->value.integer);
       else if (e->expr_type == EXPR_CONSTANT
 	       && (e->ts.u.cl == NULL || e->ts.u.cl->length == NULL))
diff --git a/gcc/testsuite/gfortran.dg/pr108421.f90 b/gcc/testsuite/gfortran.dg/pr108421.f90
new file mode 100644
index 00000000000..89439bc7eec
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr108421.f90
@@ -0,0 +1,11 @@
+! { dg-do compile }
+! PR fortran/108421
+! Contributed by G.Steinmetz
+
+program p
+  character(real(3)) :: c ! { dg-error "must be of INTEGER type" }
+  call s(c)
+end
+subroutine s(x)
+  character(*) :: x
+end

